commit fbc542de1bcf2361b9a3b5d2e52efbd5388c83bf
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Dec 28 17:41:24 2021

    fold-const: Fix up fold_truth_andor_1 shift handling [PR103813]
    
    Some time ago I've changed const_binop -> wide_int_binop, so that it punts
    on shifts by negative count.  fold_truth_andor_1 doesn't check the results
    of const_binop (?SHIFT_EXPR, ) though and assumes they will be always
    non-NULL, which is no longer the case.
    
    2021-12-28  Jakub Jelinek  <jakub@redhat.com>
    
            PR middle-end/103813
            * fold-const.c (fold_truth_andor_1): Punt of const_binop LSHIFT_EXPR
            or RSHIFT_EXPR returns NULL.  Formatting fix.
    
            * gcc.c-torture/compile/pr103813.c: New test.
    
    (cherry picked from commit 9258ac53cfcbe546e8b86a433e59343538743f74)

diff --git a/gcc/fold-const.c b/gcc/fold-const.c
index f5c19a0cfd4..50afe845c3d 100644
--- a/gcc/fold-const.c
+++ b/gcc/fold-const.c
@@ -6445,15 +6445,19 @@ fold_truth_andor_1 (location_t loc, enum tree_code code, tree truth_type,
 			 size_int (xll_bitpos));
   rl_mask = const_binop (LSHIFT_EXPR, fold_convert_loc (loc, lntype, rl_mask),
 			 size_int (xrl_bitpos));
+  if (ll_mask == NULL_TREE || rl_mask == NULL_TREE)
+    return 0;
 
   if (l_const)
     {
       l_const = fold_convert_loc (loc, lntype, l_const);
       l_const = unextend (l_const, ll_bitsize, ll_unsignedp, ll_and_mask);
       l_const = const_binop (LSHIFT_EXPR, l_const, size_int (xll_bitpos));
+      if (l_const == NULL_TREE)
+	return 0;
       if (! integer_zerop (const_binop (BIT_AND_EXPR, l_const,
 					fold_build1_loc (loc, BIT_NOT_EXPR,
-						     lntype, ll_mask))))
+							 lntype, ll_mask))))
 	{
 	  warning (0, "comparison is always %d", wanted_code == NE_EXPR);
 
@@ -6465,9 +6469,11 @@ fold_truth_andor_1 (location_t loc, enum tree_code code, tree truth_type,
       r_const = fold_convert_loc (loc, lntype, r_const);
       r_const = unextend (r_const, rl_bitsize, rl_unsignedp, rl_and_mask);
       r_const = const_binop (LSHIFT_EXPR, r_const, size_int (xrl_bitpos));
+      if (r_const == NULL_TREE)
+	return 0;
       if (! integer_zerop (const_binop (BIT_AND_EXPR, r_const,
 					fold_build1_loc (loc, BIT_NOT_EXPR,
-						     lntype, rl_mask))))
+							 lntype, rl_mask))))
 	{
 	  warning (0, "comparison is always %d", wanted_code == NE_EXPR);
 
@@ -6512,6 +6518,8 @@ fold_truth_andor_1 (location_t loc, enum tree_code code, tree truth_type,
       rr_mask = const_binop (LSHIFT_EXPR, fold_convert_loc (loc,
 							    rntype, rr_mask),
 			     size_int (xrr_bitpos));
+      if (lr_mask == NULL_TREE || rr_mask == NULL_TREE)
+	return 0;
 
       /* Make a mask that corresponds to both fields being compared.
 	 Do this for both items being compared.  If the operands are the
@@ -6571,6 +6579,8 @@ fold_truth_andor_1 (location_t loc, enum tree_code code, tree truth_type,
 				 size_int (MIN (xll_bitpos, xrl_bitpos)));
 	  lr_mask = const_binop (RSHIFT_EXPR, lr_mask,
 				 size_int (MIN (xlr_bitpos, xrr_bitpos)));
+	  if (ll_mask == NULL_TREE || lr_mask == NULL_TREE)
+	    return 0;
 
 	  /* Convert to the smaller type before masking out unwanted bits.  */
 	  type = lntype;
diff --git a/gcc/testsuite/gcc.c-torture/compile/pr103813.c b/gcc/testsuite/gcc.c-torture/compile/pr103813.c
new file mode 100644
index 00000000000..b3fc066beed
--- /dev/null
+++ b/gcc/testsuite/gcc.c-torture/compile/pr103813.c
@@ -0,0 +1,10 @@
+/* PR middle-end/103813 */
+
+struct A { char b; char c[0x21000000]; };
+struct A d;
+
+int
+foo ()
+{
+  return d.c[0x20000000] || d.c[1];
+}

